<template>
  <div v-if="!item.hidden">
    <template
      v-if="hasOneShowingChild(item.children, item) && !item.alwaysShow && (!onlyOneChild.children || onlyOneChild.noShowingChildren)"
    >
      <app-link v-if="onlyOneChild.meta" :to="resolvePath(onlyOneChild.path)">
        <el-menu-item :index="resolvePath(onlyOneChild.path)">
          <template v-if="onlyOneChild.meta.icon || (item.meta && item.meta.icon)">
            <i
              v-if="(onlyOneChild.meta.icon || (item.meta && item.meta.icon)).includes('el-icon')"
              :class="[onlyOneChild.meta.icon || (item.meta && item.meta.icon)]"
            />
          </template>
          <span
            v-if="onlyOneChild.meta && onlyOneChild.meta.title"
            slot="title"
          >{{ onlyOneChild.meta.title }}</span>
        </el-menu-item>
      </app-link>
    </template>

    <el-submenu v-else ref="subMenu" :index="resolvePath(item.path)" :popper-append-to-body="false">
      <template slot="title">
        <template v-if="(item.meta && item.meta.icon)">
          <i
            v-if="(item.meta && item.meta.icon).includes('el-icon')"
            :class="[(item.meta && item.meta.icon)]"
          />
        </template>
        <span v-if="item.meta && item.meta.title" v-show="!isCollapse" slot="title">{{ item.meta.title }}</span>
      </template>
      <sidebar-item
        v-for="child in item.children"
        :key="child.path"
        :item="child"
        :base-path="resolvePath(child.path)"
      />
    </el-submenu>
  </div>
</template>

<script >
import { defineComponent } from "@vue/composition-api";
import path from 'path-browserify'
import { isExternal } from '@/utils/validate'
import AppLink from './Link.vue'
import { useSidebarStore } from '@/stores/sidebar'


export default defineComponent({
  name: 'SidebarItem',
  components: {
    AppLink
  },
  // render() {
  //   console.log('args :>> ', this);
  //   return (<el-button>hi</el-button>)
  // },
  props: {
    item: {
      type: Object,
      required: true
    },
    basePath: {
      type: String,
      default: ''
    }
  },
  data() {
    // To fix https://github.com/PanJiaChen/vue-admin-template/issues/237
    // TODO: refactor with render function
    this.onlyOneChild = null
    return {}
  },
  computed:{
    isCollapse(){
      return useSidebarStore().isCollapse
    }
  },
  methods: {
    hasOneShowingChild(children = [], parent) {
      const showingChildren = children.filter(item => {
        if (item.hidden) {
          return false
        } else {
          // Temp set(will be used if only has one showing child)
          this.onlyOneChild = item
          this.onlyOneChild.noShowingChildren = item.children && item.children.filter(c => !c.hidden).length === 0
          return true
        }
      })
      // When there is only one child router, the child router is displayed by default
      if (showingChildren.length === 1) {
        return true
      }

      // Show parent if there are no child router to display
      if (showingChildren.length === 0) {
        this.onlyOneChild = { ...parent, path: '', noShowingChildren: true }
        return true
      }

      return false
    },
    resolvePath(routePath) {
      if (isExternal(routePath)) {
        return routePath
      }
      if (isExternal(this.basePath)) {
        return this.basePath
      }
      return path.resolve(this.basePath, routePath)
    }
  }
})
</script>
